#include <QMainWindow>
#include <QPlainTextEdit>
#include <QThread>
#include <QLineEdit>

class my_thread : public QThread
{
  Q_OBJECT

private:
  void run (void) Q_DECL_OVERRIDE;

signals:
  void done (int line, int column, const QString &status);
};

class main_window : public QMainWindow
{
  Q_OBJECT

private slots:
  void text_changed (void);
  void draw (int line, int column, const QString &status);

private:
  my_thread *thr;

public:
  QPlainTextEdit *text_edit;
  QLineEdit *program_line_edit;
  QLineEdit *source_line_edit;

  explicit main_window (QWidget *parent = 0);
  ~main_window (void);
};
